#!/usr/bin/env python

# Authors: Xiaohong Zhuang, Dr.Jeffery B. Klauda
# Date:3/11/2016
	
import math
import numpy as np

# Update the number of each lipid component per leaflet in the same order as in def_nlip.str and lipid.dat
Nlist = [28,12,13,9,5,22,7,4]

# Read the block-average data file
filetoread = "2_avg_vertical_all.txt" 
data=np.genfromtxt(filetoread)
NR = np.shape(data)[0]; NC = np.shape(data)[1];

if NC == len(Nlist):
	Col_avg = np.mean(data,axis=0)  # axis=0 column-wise mean; axis=1 row-wise mean
	Col_std = np.std(data,axis=0)   # column-wise stardard deviation of block average	
	SumA=0;
	for j in range(0,NC,1):
		SumA+=Col_avg[j]*Nlist[j];
		print "%3.4f\t%3.4f" % (Col_avg[j] ,Col_std[j])
	print " "
	print "N_comp: ", NC
	print "N_lip_per_leaf: ", sum(Nlist)
	print "Comp_SA_sum: %6.4f" % SumA
else:
	print "Error! The number of components does not match!"