#!/usr/bin/env python

# Authors: Xiaohong Zhuang, Dr.Jeffery B. Klauda
# Date:3/11/2016

import math
import numpy as np

# Read number of dyn
fob = open('Ndyn.txt','r')
Ndyn = fob.readline()
Ndyn = Ndyn.strip()
fob.close()

# Update the number of each lipid component per leaflet in the same order as in def_nlip.str and lipid.dat
Nlist = [28,12,13,9,5,22,7,4]

# Read the block-average data file
filetoread1 = "tmp/%s/atomic-area.dat" % Ndyn
tdata=np.genfromtxt(filetoread1,delimiter="\t")

filetoread2 = "tmp/bot/%s/atomic-area.dat" % Ndyn
bdata=np.genfromtxt(filetoread2,delimiter="\t")

NR = np.shape(tdata)[0]; NC = np.shape(tdata)[1];
#print NR,NC

# remove the last empty column
tdata = tdata[:,0:NC-1]; bdata = bdata[:,0:NC-1];
# Find the  average of each column
t_avg = np.mean(tdata,axis=0);b_avg = np.mean(bdata,axis=0)  # axis=0 column-wise mean; axis=1 row-wise mean

def Calc_Area(Col_avg):
	Alist = [];SumN = 0;
	for i in range(0,len(Nlist),1):
		if i==0 and Nlist[0]>0:
			lip = Col_avg[SumN:(SumN+Nlist[i])];			
			SumN=SumN + Nlist[i];
			Alist.append(sum(lip)/float(Nlist[i]))
		else:
			lip = Col_avg[SumN:(SumN+3*Nlist[i])];			
			SumN=SumN + 3*Nlist[i];
			Alist.append(sum(lip)/float(Nlist[i]))
	return Alist

for i in range(0,len(Nlist),1):
	print '%6.7f' % ((Calc_Area(t_avg)[i]+Calc_Area(b_avg)[i])/2.0),

