/* This Program Calculates The PDF of Lipid Areas (Polyhedra)       */
/* Created by: Dr. Jeff Klauda                                       */
/* Date: 12/16/2010                                                  */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

FILE *main_inp;
FILE *main_inp2;
FILE *main_out;
FILE *main_out2;

double dist2[15][100][150]; //sets max number of [lipids][ntot/blks][max dist-dataset]

#define MAX_R 2000000 

void dist(double area, int nlipid, double blks, double min, double max, int nl, int m, double delta);

int main(void)
{
    char input[80],input2[80],output[80],output2[80];
    int i,j,status,chol,natom,m,m1,N_lipid,k;
    int n,cnt;
    double a[5000],min[10],max[10],blks,ntot,area,dl,dc;

    for(i=0;i<10;i++)
	for(j=0;j<100;j++)
		for(m=0;m<100;m++)
			dist2[i][j][m]=0;

    printf("\n\n# of Lipids types incl. Chols: ");
    scanf("%d",&N_lipid);
    int nlipid[N_lipid];

    printf("\n\nArea Data File: ");
    scanf("%s",&input);
    main_inp = fopen (input,"r");

//  Lipid file with (colestrol) (# of lipids 1-n)

    printf("\n\nLipid Data File: ");
    scanf("%s",&input2);
    main_inp2 = fopen (input2,"r");

    fscanf(main_inp2,"%d",&chol);	/* 0-no cholesterol 1-cholesterol */
    for(i=0;i<N_lipid;i++)
	fscanf(main_inp2,"%d",&nlipid[i]);
    
    if(chol)
	natom=nlipid[0];
    else
	natom=nlipid[0]*3;

    for(i=1;i<N_lipid;i++)
	natom= natom + 3*nlipid[i];
    
    printf("\n\n Min, Max, and Delta for Chol Area: ");
    scanf("%lf%lf%lf",&min[0],&max[0],&dc);

    printf("\n\n Min, Max, and Delta for Lipid 1 Area: ");
    scanf("%lf%lf%lf",&min[1],&max[1],&dl);

    printf("\n\nOutput Chol File: ");
    scanf("%s",&output);
    main_out = fopen (output,"w");

    printf("\n\nOutput Lipid1 File: ");
    scanf("%s",&output2);
    main_out2 = fopen (output2,"w");

    printf("\n\nBlock Size & Total Steps: ");
    scanf("%lf%lf",&blks,&ntot);

// Read in data

    i=-1;
    for(j=0;j<natom;j++)
                status=fscanf(main_inp,"%lf",&a[j]);

    for(i=0;i<ntot/blks;i++) 
    {
        for(m1=0;m1<blks;m1++) 
	{
	if(chol==1)
	{
	    for(j=0;j<nlipid[0];j++)
	    {
	    	area=a[j];
		dist(area,nlipid[0],blks,min[0],max[0],0,i,dc);
	    }
	    cnt=0;
	    for(j=1;j<N_lipid;j++)
	    {
		cnt=cnt+nlipid[j-1];
		for(n=0;n<nlipid[j];n++)
		{
			area=0;
			for(m=0;m<3;m++)
				area=area+a[cnt+3*n+m];
			dist(area,nlipid[j],blks,min[1],max[1],j,i,dl);
			area=0;

		}
	    }
	    
	}
	else    // if NO cholesterol in the membrane
	{
		// Blank for now
		// Xiao: Added the else statement for systems without sterol 
	    cnt=0;
	    for(j=0;j<N_lipid;j++)
	    {
		cnt=cnt+nlipid[j-1];
		for(n=0;n<nlipid[j];n++)
		{
			area=0;
			for(m=0;m<3;m++)
				area=area+a[cnt+3*n+m];
			dist(area,nlipid[j],blks,min[1],max[1],j,i,dl);
			area=0;

		}
	    }
	}

	for(j=0;j<natom;j++)
                fscanf(main_inp,"%lf",&a[j]);
	}
    }
    fclose(main_inp);
    fclose(main_inp2);

//  Print out Blocked Distributions
// Xiao: Add the if else loop below to include case of no cholestrol system
    if(chol==1)
    {   
    for(j=0;j<(max[0] - min[0])/dc + 1;j++)
    {
	fprintf(main_out,"%1.5lf\t",min[0]+j*dc);
	for(m=0;m<ntot/blks;m++)
	{
	    fprintf(main_out,"%1.5lf\t",dist2[0][m][j]);
	    
	}
	fprintf(main_out,"\n");
    }

    for(j=0;j<(max[1] - min[1])/dl + 1;j++)
    {
        fprintf(main_out2,"%1.5lf\t",min[1]+j*dl);
        for(m=0;m<ntot/blks;m++)
        {
	  for(k=1;k<N_lipid;k++)
            {
            fprintf(main_out2,"%1.5lf\t",dist2[k][m][j]);
	    }
        }
        fprintf(main_out2,"\n");
    }

    }

	else    // if NO cholesterol in the membrane 
    {   
    for(j=0;j<(max[0] - min[0])/dc + 1;j++)
    {
	fprintf(main_out,"%1.5lf\t",min[0]+j*dc);
	for(m=0;m<ntot/blks;m++)
	{
	    fprintf(main_out,"%1.5lf\t",0.0);
	    
	}
	fprintf(main_out,"\n");
    }

    for(j=0;j<(max[1] - min[1])/dl + 1;j++)
    {
        fprintf(main_out2,"%1.5lf\t",min[1]+j*dl);
        for(m=0;m<ntot/blks;m++)
        {
	  for(k=0;k<N_lipid;k++)
            {
            fprintf(main_out2,"%1.5lf\t",dist2[k][m][j]);
	    }
        }
        fprintf(main_out2,"\n");
    }
}

}

void dist(double area, int nlipid, double blks, double min, double max, int nl, int m, double delta)
{
    double tot;
    int i,j,nit;

    tot = nlipid*blks;
    nit = (max - min)/delta + 1;

    for(i=0;i<nit;i++)
    {
	if(area<(min+delta*i))
	{
	     dist2[nl][m][i]=dist2[nl][m][i]+1/tot;
	     i=nit+1;
	}
	else if(i==(nit-1))
	{
	     dist2[nl][m][i]=dist2[nl][m][i]+1/tot;
	     i=nit+1;
	}
    }
}
