#!/bin/csh
#SBATCH --ntasks=1
#SBATCH -N 1
#SBATCH --job-name=hypo-b1-SA
#SBATCH -t 02:00:00
#SBATCH --constraint="[ib|qib]"

unset noclobber

# CHANGE TO SUBMISSION SUBDIR
cd $SLURM_SUBMIT_DIR
module load openmpi/1.6
module load fftw/3.3.3/gnu/4.6.1/openmpi/1.6/shared
setenv LD_LIBRARY_PATH $FFTWLIB
# XZ: Turn off the mpi warning as infiniband is being used with the OFED verbs driver.
setenv OMPI_MCA_mpi_warn_on_fork 0 

# CHARMM version
# In DT1
set chm = "/lustre/home/jbklauda/charmm/c39a2wxw/myc39a2/exec/gnu_M/gfortcol.om"
# In DT2
#set chm = "/lustre/xzhuang/software/charmm/c39a2/gnu_M/gfortcol.om"
hostname

set uno = $1 # (#chol + 3*#lipids)
set dos = $2 # (#chol + 3*#lipids +1)
set dir = "$6"
set inp = "$7"

module load openmpi/1.6
module load fftw/3.3.3/gnu/4.6.1/openmpi/1.6/shared
setenv LD_LIBRARY_PATH $FFTWLIB
@ start = $3
@ startd = $5

@ i = $start # first dcd # (NOT dcd file, but # DCDs looking at
@ k = $i + $startd # this counts actual name of DCD file
while ( $i <= $4) # last dcd #
mkdir $dir/$i
cp -f area.exe $dir/$i
cp -f lipid.dat $dir/$i
cp -f top $dir/$i
cp -f bot $dir/$i
cp -f dist.exe $dir/$i
# INVOKE CHARMM
$chm N=$k D=$i atoms=$uno atoms1=$dos molecs=$8 images=$9 < $inp.inp > tmp/$inp-$k.out &
@ i = $i + 1
@ k = $k + 1
end

echo $i
echo $k
echo "Finished section"
echo " "
echo " "
wait
